#include <TinyGPS++.h>

// мои координаты 55.82070,37.58230
TinyGPSPlus gps;                                   // Объект  TinyGPS++.

#define Lat 55.82070                               // Широта местоположения стоянки машины
#define Long 37.58230                              // Долгота местоположения стоянки машины
#define Radius 0.001                               // Безопасный радиус
#define Pausa 5000                                 // Пауза 5 секунд
unsigned long last_time;                           // Переменная для хранения времени

float Temp_Lat = 0.00;
float Temp_Long = 0.00;


#define LED D1                                     // Контакт для сирены(пока светодиод)

void setup()
{
  Serial.begin(9600);                              // Скорость UART
  pinMode(LED, OUTPUT);                            // Пин на Выход
}

void loop(){
 if(millis() - last_time > Pausa) {                // 5 сек
  while (Serial.available() > 0)                   // Если есть данные то...
  {
    if (gps.encode(Serial.read()))                 // Декодирование GPS NMEA.
    {
      bool status = NeedToNotify();                // Статус Истина или Ложь.
      if (status == true)
      {
        TurnOnAlarm();                             // Вызов функции Включения сигнала тревоги
      }
      else
      {
        TurnOffAlarm();                            // Вызов функции Выключения сигнала тревоги
      }
      delay(100);
    }
  }
    last_time = millis();
}
  
}
bool NeedToNotify()
{
  if (gps.location.isValid())                     // Если координаты получены
  {
    double lat, lng, latOffset, lngOffset;

    lat = gps.location.lat();
    lng = gps.location.lng();

    // Выводим координты в монитор порта
    Serial.print(F("Координаты: ")); 
    Serial.print(lat, 5);                                       // Выводим Широту.      
    Serial.print(F(","));
    Serial.print(lng, 5);                                       // Выводим Долготу. 

    if(lng >= Long)Temp_Long = lng - Long;
    if(lng <= Long)Temp_Long = Long - lng;
    if(lat >= Lat) Temp_Lat = lat - Lat; 
    if(lat <= Lat) Temp_Lat = Lat - lat;
        
    if(Temp_Long > Radius || Temp_Lat > Radius)         
    {
      return true;                                              // Пользователь достиг пределов области.
    }
  }
  else
  {
    Serial.print(F("Ошибка в получении GPS-координат, проверьте подключение."));
  } 
  return false; 
}
void TurnOnAlarm()
{
  Serial.println(" \t Устройство находится за пределами области. Включить сигнализацию");
  digitalWrite(LED, HIGH);
}
void TurnOffAlarm()
{
  Serial.println(" \t Сигнализация выключена");
  digitalWrite(LED, LOW);
}
